<template>
  <div >

    <div class="card pt-2">
      <div class="p-2 pb-4">
        <button v-if="!readonly" class="btn btn-default btn-primary" @click="openAddNailWindow()">Pridať klince</button>
        <button v-if="!readonly" class="btn btn-default btn-primary" @click="savePriceListItems()">Uložiť parametre</button>
        <button class="btn btn-default btn-primary float-right" @click="exportPDF()">Export PDF</button>
        <div style="clear: both;"></div>
      </div>

<!--
      <div class="flex items-center py-3 border-b border-50">
        <div class="flex items-center">
          <div class="px-3">
            <div class="v-popover -mx-2" dusk="select-all-dropdown">
              <div class="trigger" style="display: inline-block;">
                <button type="button" class="rounded active:outline-none active:shadow-outline focus:outline-none focus:shadow-outline">
                  <div class="
                    dropdown-trigger
                    h-dropdown-trigger
                    flex
                    items-center
                    cursor-pointer
                    select-none
                    px-2"
                  >
                    <input type="checkbox" disabled="disabled" class="checkbox pointer-events-none">
                    <svg xmlns="http://www.w3.org/2000/svg" width="10" height="6" viewBox="0 0 10 6" class="ml-2">
                      <path fill="var(--90)" d="M8.292893.292893c.390525-.390524 1.023689-.390524 1.414214 0 .390524.390525.390524 1.023689 0 1.414214l-4 4c-.390525.390524-1.023689.390524-1.414214 0l-4-4c-.390524-.390525-.390524-1.023689 0-1.414214.390525-.390524 1.023689-.390524 1.414214 0L5 3.585786 8.292893.292893z"></path>
                    </svg>
                  </div>
                </button>
              </div>
            </div>
          </div>
        </div>
        <div class="flex items-center ml-auto px-3">
          <div>
            <div class="filter-menu-dropdown">
              <div class="v-popover" dusk="filter-selector">
                <div class="trigger" style="display: inline-block;">
                  <button type="button" class="rounded active:outline-none active:shadow-outline focus:outline-none focus:shadow-outline">
                    <div class="
                      dropdown-trigger
                      h-dropdown-trigger
                      flex
                      items-center
                      cursor-pointer
                      select-none
                      bg-30 px-3 border-2 border-30 rounded"
                    >
                      <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 20 20" aria-labelledby="filter" role="presentation" class="fill-current text-80">
                        <path fill-rule="nonzero" d="M.293 5.707A1 1 0 0 1 0 4.999V1A1 1 0 0 1 1 0h18a1 1 0 0 1 1 1v4a1 1 0 0 1-.293.707L13 12.413v2.585a1 1 0 0 1-.293.708l-4 4c-.63.629-1.707.183-1.707-.708v-6.585L.293 5.707zM2 2v2.585l6.707 6.707a1 1 0 0 1 .293.707v4.585l2-2V12a1 1 0 0 1 .293-.707L18 4.585V2H2z"></path>
                      </svg>
                      <svg xmlns="http://www.w3.org/2000/svg" width="10" height="6" viewBox="0 0 10 6" class="ml-2">
                        <path fill="var(--90)" d="M8.292893.292893c.390525-.390524 1.023689-.390524 1.414214 0 .390524.390525.390524 1.023689 0 1.414214l-4 4c-.390525.390524-1.023689.390524-1.414214 0l-4-4c-.390524-.390525-.390524-1.023689 0-1.414214.390525-.390524 1.023689-.390524 1.414214 0L5 3.585786 8.292893.292893z"></path>
                      </svg>
                    </div>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      -->
      <div class="relative">
        <div class="overflow-hidden overflow-x-auto relative" style="">

          <table cellpadding="0" cellspacing="0" data-testid="resource-table" class="table w-full table-default">

            <thead>
              <tr>
                <th class="w-16">&nbsp;</th>
                <th v-for="(headerItem,index) in priceListItemsHeader" :key="index"  class="text-left">
                    {{ headerItem.title }}
                </th>
                <th>&nbsp;</th>
              </tr>
            </thead>

            <tbody>
              <price-list-items-form-row
                v-for="(priceListItem,index) in priceListItems" :key="priceListItem.id"
                v-model="priceListItems[index]"
                :readonly="readonly"
                @delete-row="loadPriceListItems()"
              ></price-list-items-form-row>

            </tbody>
          </table>
        </div>

        <!--
        <div class="bg-20 rounded-b-lg" per-page="25" resource-count-label="1-8 z 8" current-resource-count="8" all-matching-resource-count="8"><nav class="flex items-center"><div class="flex text-sm"><button disabled="disabled" rel="first" dusk="first" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        «
      </button> <button disabled="disabled" rel="prev" dusk="previous" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        ‹
      </button> <button dusk="page:1" class="btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        1
      </button> <button disabled="disabled" rel="next" dusk="next" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        ›
      </button> <button disabled="disabled" rel="last" dusk="last" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        »
      </button></div> <span class="text-sm text-80 px-4 ml-auto">
          1-8 z 8
        </span></nav></div>
        -->
      </div>
    </div>


    <add-nails-window
      v-if="showAddNailWindow"
      :nailCategories="panel.fields[0].nailCategories"
      :nailFinishies="panel.fields[0].nailFinishies"
      :priceListId="resourceId"
      @close="closeAddNailWindow($event)"
    ></add-nails-window>

  </div>

</template>

<script>
import AddNailsWindow from './AddNailsWindow.vue'
import PriceListItemsFormRow from './PriceListItemsFormRow.vue'

export default {
  components: {AddNailsWindow, PriceListItemsFormRow},
  props: ['resourceName', 'resourceId', 'panel'],
  data: () => ({
    showAddNailWindow: false,
    priceListItems: [],
    priceListItemsHeader: [
      {title: 'Klinec'},
      {title: 'Váha 1000 ks [kg]'},
      {title: 'Cena drôtu [eur/t]'},
      {title: 'Cenový koeficient'},
      {title: 'Povrchová úprava koeficient'},
      {title: 'Prirážka [%]'},
      {title: 'Cena za 1000 ks [eur]'},
    ]
  }),
  computed: {
    readonly () {
      return  !this.panel.fields[0].isLast
    }
  },
  methods: {
    openAddNailWindow() {
      this.showAddNailWindow = true;
    },
    closeAddNailWindow(refresh) {
      console.log(refresh)
      if (refresh === true) {
        this.loadPriceListItems()
      }
      this.showAddNailWindow = false;

    },
    loadPriceListItems () {
        Nova.request().get('/nova-vendor/price-list-items-form/get-price-list-items?priceListId=' + this.resourceId)
            .then(response => {
                this.priceListItems = response.data
            })
    },
    savePriceListItems () {
      let data = {}
      data.priceListId = this.resourceId
      data.priceListItems = this.priceListItems

      Nova.request().post('/nova-vendor/price-list-items-form/save-price-list-items', data)
            .then(response => {
                this.$toasted.success('Parametre boli úspešne uložené.');
                console.log(response)
            })
    },
    exportPDF() {
      let data = {}
      data.priceListId = this.resourceId

      Nova.request().post('/nova-vendor/price-list-items-form/get-price-list-pdf', data, {responseType: 'arraybuffer'})
            .then(response => {
                this.downloadFile(response)
            })
    },
    downloadFile(response) {
      // It is necessary to create a new blob object with mime-type explicitly set
      // otherwise only Chrome works like it should
      var filename = response.headers['content-disposition'].split('=')[1].replace(/^\"+|\"+$/g, '')

      var newBlob = new Blob([response.data], {type: 'application/pdf'})

      // IE doesn't allow using a blob object directly as link href
      // instead it is necessary to use msSaveOrOpenBlob
      if (window.navigator && window.navigator.msSaveOrOpenBlob) {
        window.navigator.msSaveOrOpenBlob(newBlob)
        return
      }

      // For other browsers:
      // Create a link pointing to the ObjectURL containing the blob.
      const data = window.URL.createObjectURL(newBlob)
      var link = document.createElement('a')
      link.href = data
      link.download = filename
      link.click()
      setTimeout(function () {
        // For Firefox it is necessary to delay revoking the ObjectURL
        window.URL.revokeObjectURL(data)
      }, 100)
    },
  },
  mounted() {
    this.loadPriceListItems()
  },
}
</script>
